/*
 * libdigidocpp
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#pragma once

#include <openssl/x509.h>

#define DECLARE_OPENSSL_RELEASE_STRUCT(type) \
struct type##_scope \
{ \
    type** p; \
    type##_scope(type** p) { this->p = p; } \
    ~type##_scope() { if(p && *p) { type##_free(*p); *p = NULL; } } \
};

struct X509Stack_scope
{
    STACK_OF(X509)** p;
    X509Stack_scope(STACK_OF(X509)** p) { this->p = p; }
    ~X509Stack_scope() { if(p && *p) { sk_X509_pop_free(*p, X509_free); *p = NULL; } }
};

DECLARE_OPENSSL_RELEASE_STRUCT(X509)
