/*
 * libdigidocpp
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#pragma once

#include "EstEIDSigner.h"

namespace digidoc
{
    /**
     * EstEID ID-Card signer with interactive PIN acquisition from console.
     *
     * @author Janari Põld
     */
    class EstEIDConsolePinSigner : public EstEIDSigner
    {

      public:
          EstEIDConsolePinSigner(const std::string &driver, const std::string &prompt) throw(SignException);
          EstEIDConsolePinSigner(const std::string &driver) throw(SignException);
          virtual ~EstEIDConsolePinSigner();
          void setPrompt(const std::string &prompt);

      protected:
          virtual std::string getPin(const PKCS11Cert &certificate) throw(SignException);

      private:
          std::string prompt;

    };

}
